<?php
namespace Teknisa\PED\Modules\Expedicao\Services;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\ORM\DateTime;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Teknisa\PED\Factories\Exp00200LancamentoExpedicaoPedidoFactory;

class Exp00200LancamentoExpedicaoPedidoService {

    protected $connection;
    protected $entityManager;
    protected $lancamentoExpedicaoPedidoFactory;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager, $lancamentoExpedicaoPedidoFactory)  {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
        $this->lancamentoExpedicaoPedidoFactory = $lancamentoExpedicaoPedidoFactory;
    }

    public function validaExpedicao($pedido) {
        return $this->lancamentoExpedicaoPedidoFactory->validaExpedicao($pedido);
    }
    
    public function callProcedureGERA_NOTAFISCAL_CORPO($corpoNF) {
        $erro = $this->lancamentoExpedicaoPedidoFactory->callProcedureGERA_NOTAFISCAL_CORPO($corpoNF);
        return $erro;
    }
    
    public function callProcedureGERA_NOTAFISCAL_PRODUTO($produtoNF) {
        $data = $this->lancamentoExpedicaoPedidoFactory->callProcedureGERA_NOTAFISCAL_PRODUTO($produtoNF);
        return $data;
    }
    
    public function callProcedureGERA_NOTAFISCAL_ENCARGO($encargoNF) {
        $erro = $this->lancamentoExpedicaoPedidoFactory->callProcedureGERA_NOTAFISCAL_ENCARGO($encargoNF);
        return $erro;
    } 
    
    public function callProcedureGERA_NOTAFISCAL_DADOSADIC($dadosadicNF) {
        $erro = $this->lancamentoExpedicaoPedidoFactory->callProcedureGERA_NOTAFISCAL_DADOSADIC($dadosadicNF);
        return $erro;
    }
    
    public function callProcedureGERA_NOTAFISCAL_FECHAMENTO($fechamentoNF) {
        $erro = $this->lancamentoExpedicaoPedidoFactory->callProcedureGERA_NOTAFISCAL_FECHAMENTO($fechamentoNF);
        return $erro;
    }
    
    public function getItensPed($cdfilial, $nrpedido){
        $data = $this->lancamentoExpedicaoPedidoFactory->getItensPed($cdfilial, $nrpedido);
        return $data;
    }

    public function getEncargoPed($cdfilial, $nrpedido){
        $data = $this->lancamentoExpedicaoPedidoFactory->getEncargoPed($cdfilial, $nrpedido);
        return $data;
    }

    public function getDadosAdicPed($cdfilial, $nrpedido){
        $data = $this->lancamentoExpedicaoPedidoFactory->getDadosAdicPed($cdfilial, $nrpedido);
        return $data;
    }
    
    public function getDataProc($cdfilial){
        $data = $this->lancamentoExpedicaoPedidoFactory->getDataProc($cdfilial);
        return $data;
    }
    
    public function getTipooperac($cdtipooer){
        $data = $this->lancamentoExpedicaoPedidoFactory->getTipooperac($cdtipooer);
        return $data;
    }
    public function getParamsFilial($cdfilial){
        $data = $this->lancamentoExpedicaoPedidoFactory->getParamsFilial($cdfilial);
        return $data;
    }
    public function getParamsExp($cdfilial){
        $data = $this->lancamentoExpedicaoPedidoFactory->getParamsExp($cdfilial);
        return $data;
    }
    public function getViatura($cdviatura){
        $data = $this->lancamentoExpedicaoPedidoFactory->getViatura($cdviatura);
        return $data;
    }
    public function getTransportadora($nrinsjurtran){
        $data = $this->lancamentoExpedicaoPedidoFactory->getTransportadora($nrinsjurtran);
        return $data;
    }
    
    public function verificaIndice($nrpedido, $cdfilial, $data){
        $data = $this->lancamentoExpedicaoPedidoFactory->verificaIndice($nrpedido, $cdfilial, $data);
        return $data;
    }
    
    /**
     * INICIO METODOS APP CONFERENCIA DE SEPARACAÇÃO
    */
    
    public function verificaProdutoCompoeNota($cdfilial, $nrlanctonf, $cdproduto){
        return $this->lancamentoExpedicaoPedidoFactory->verificaProdutoCompoeNota($cdfilial, $nrlanctonf, $cdproduto);
    }
    
    public function verificaLoteNota($cdfilial, $cdproduto, $nrloteestq, $nrsublote){
        return $this->lancamentoExpedicaoPedidoFactory->verificaLoteNota($cdfilial, $cdproduto, $nrloteestq, $nrsublote);
    }
    
    public function getReservaItemprod($cdfilial, $nrlanctonf, $nrseqitprod, $cdproduto, $cdalmoxprcli, $cdlocalprcli, $nrloteestq, $nrsublote){
        return $this->lancamentoExpedicaoPedidoFactory->getReservaItemprod($cdfilial, $nrlanctonf, $nrseqitprod, $cdproduto, $cdalmoxprcli, $cdlocalprcli, $nrloteestq, $nrsublote);
    }
    
    public function getMaxNrresprodped($cdfilial, $nrlanctonf, $nrseqitprod){
        return $this->lancamentoExpedicaoPedidoFactory->getMaxNrresprodped($cdfilial, $nrlanctonf, $nrseqitprod);
    }
    
    public function insertColeta($cdfilial, $nrlanctonf, $nrseqcontainer, $nrseqcoleta, $cdproduto, $nrloteestq, $nrsublote, $qtresprodped){
        return $this->lancamentoExpedicaoPedidoFactory->insertColeta($cdfilial, $nrlanctonf, $nrseqcontainer, $nrseqcoleta, $cdproduto, $nrloteestq, $nrsublote, $qtresprodped);
    }
    
    public function updateReservaItemprodSoma($qtresprodped, $cdfilial, $nrlanctonf, $nrseqitprod, $nrresprodped){
        return $this->lancamentoExpedicaoPedidoFactory->updateReservaItemprodSoma($qtresprodped, $cdfilial, $nrlanctonf, $nrseqitprod, $nrresprodped);
    }
    
    public function updateReservaItemprod($qtresprodped, $cdfilial, $nrlanctonf, $nrseqitprod, $nrresprodped){
        return $this->lancamentoExpedicaoPedidoFactory->updateReservaItemprod($qtresprodped, $cdfilial, $nrlanctonf, $nrseqitprod, $nrresprodped);
    }
    
    public function insereReservaItemprod($cdfilial, $nrlanctonf, $nrseqitprod, $nrresprodped, $cdproduto, $cdalmoxarife, $cdlocalestoq, $nrloteestq, $nrsublote, $qtresprodped, $idstatusreser){
        return $this->lancamentoExpedicaoPedidoFactory->insereReservaItemprod($cdfilial, $nrlanctonf, $nrseqitprod, $nrresprodped, $cdproduto, $cdalmoxarife, $cdlocalestoq, $nrloteestq, $nrsublote, $qtresprodped, $idstatusreser);
    }
    
    public function getQtdeItemProd($cdfilial, $nrlanctonf, $nrseqitprod){
        return $this->lancamentoExpedicaoPedidoFactory->getQtdeItemProd($cdfilial, $nrlanctonf, $nrseqitprod);
    }
    
    public function getQtdeReser($cdfilial, $nrlanctonf, $nrseqitprod){
        return $this->lancamentoExpedicaoPedidoFactory->getQtdeReser($cdfilial, $nrlanctonf, $nrseqitprod);
    }
    
    public function updateStItemproduto($cdfilial, $nrlanctonf, $nrseqitprod, $qtseparada, $idstatusreser){
        return $this->lancamentoExpedicaoPedidoFactory->updateStItemproduto($cdfilial, $nrlanctonf, $nrseqitprod, $qtseparada, $idstatusreser);
    }
    
    public function getSumQtdeItemProd($cdfilial, $nrlanctonf, $cdproduto){
        return $this->lancamentoExpedicaoPedidoFactory->getSumQtdeItemProd($cdfilial, $nrlanctonf, $cdproduto);
    }
    
    public function getSumQtdeReser($cdfilial, $nrlanctonf, $cdproduto){
        return $this->lancamentoExpedicaoPedidoFactory->getSumQtdeReser($cdfilial, $nrlanctonf, $cdproduto);
    }
    
    public function updateStReseritemprod($idstatusreser, $cdfilial, $nrlanctonf, $nrseqitprod, $nrseqcontainer, $nrresprodped){
        return $this->lancamentoExpedicaoPedidoFactory->updateStReseritemprod($idstatusreser, $cdfilial, $nrlanctonf, $nrseqitprod, $nrseqcontainer, $nrresprodped);
    }
    
    public function deleteColeta($cdfilial, $nrlanctonf, $cdproduto, $nrseqcontainer){
        return $this->lancamentoExpedicaoPedidoFactory->deleteColeta($cdfilial, $nrlanctonf, $cdproduto, $nrseqcontainer);
    }
    
    public function getColetaPorVolume($cdfilial, $nrlanctonf, $nrseqcontainer){
        return $this->lancamentoExpedicaoPedidoFactory->getColetaPorVolume($cdfilial, $nrlanctonf, $nrseqcontainer);
    }
    
    public function getQtColetadaVol($cdfilial, $nrlanctonf, $nrseqcontainer){
        return $this->lancamentoExpedicaoPedidoFactory->getQtColetadaVol($cdfilial, $nrlanctonf, $nrseqcontainer);
    }
    
    public function getQtColetadaNF($cdfilial, $nrlanctonf){
        return $this->lancamentoExpedicaoPedidoFactory->getQtColetadaNF($cdfilial, $nrlanctonf);
    }
    
    public function updateQtColetadaVol($qtcoletada, $cdfilial, $nrlanctonf, $nrseqcontainer){
        return $this->lancamentoExpedicaoPedidoFactory->updateQtColetadaVol($qtcoletada, $cdfilial, $nrlanctonf, $nrseqcontainer);
    }
    
    public function getItemproduto($cdfilial, $nrlanctonf, $cdproduto){
        return $this->lancamentoExpedicaoPedidoFactory->getItemproduto($cdfilial, $nrlanctonf, $cdproduto);
    }
    
    public function getMaxItemprod($cdfilial, $nrlanctonf, $cdproduto){
        return $this->lancamentoExpedicaoPedidoFactory->getMaxItemprod($cdfilial, $nrlanctonf, $cdproduto);
    }
    
    public function getMaxNrseqcoleta($cdfilial, $nrlanctonf, $nrseqcontainer){
        return $this->lancamentoExpedicaoPedidoFactory->getMaxNrseqcoleta($cdfilial, $nrlanctonf, $nrseqcontainer);
    }
    
    public function deleteColetaVol($cdfilial, $nrlanctonf, $nrseqcontainer, $nrseqcoleta){
        return $this->lancamentoExpedicaoPedidoFactory->deleteColetaVol($cdfilial, $nrlanctonf, $nrseqcontainer, $nrseqcoleta);
    }
    
    public function updateQtColetadaVolDel($qtcoletada, $cdfilial, $nrlanctonf, $nrseqcontainer){
        return $this->lancamentoExpedicaoPedidoFactory->updateQtColetadaVolDel($qtcoletada, $cdfilial, $nrlanctonf, $nrseqcontainer);
    }
    
    public function deleteReservaItemprod($cdfilial, $nrlanctonf, $cdproduto){
        return $this->lancamentoExpedicaoPedidoFactory->deleteReservaItemprod($cdfilial, $nrlanctonf, $cdproduto);
    }
    
    public function updateStItemprodutoDel($cdfilial, $nrlanctonf, $cdproduto, $qtseparada, $idstatusreser){
        return $this->lancamentoExpedicaoPedidoFactory->updateStItemprodutoDel($cdfilial, $nrlanctonf, $cdproduto, $qtseparada, $idstatusreser);
    }
    
    public function getColetaVol($cdfilial, $nrlanctonf, $cdproduto){
        return $this->lancamentoExpedicaoPedidoFactory->getColetaVol($cdfilial, $nrlanctonf, $cdproduto);
    }
    
    public function getColetaExcedida($cdfilial, $nrlanctonf, $nrseqcontainer){
        return $this->lancamentoExpedicaoPedidoFactory->getColetaExcedida($cdfilial, $nrlanctonf, $nrseqcontainer);
    }
    
    public function updateStVolumeConcluido($cdfilial, $nrlanctonf, $nrseqcontainer, $idstatuscol){
        return $this->lancamentoExpedicaoPedidoFactory->updateStVolumeConcluido($cdfilial, $nrlanctonf, $nrseqcontainer, $idstatuscol);
    }
    
    public function getVolumesExp($cdfilial, $nrlanctonf){
        return $this->lancamentoExpedicaoPedidoFactory->getVolumesExp($cdfilial, $nrlanctonf);
    }
    
    public function updateStNfColetada($cdfilial, $nrlanctonf, $idstatussep){
        return $this->lancamentoExpedicaoPedidoFactory->updateStNfColetada($cdfilial, $nrlanctonf, $idstatussep);
    }
    
    public function getStContainer($cdfilial, $nrlanctonf, $nrseqcontainer){
        return $this->lancamentoExpedicaoPedidoFactory->getStContainer($cdfilial, $nrlanctonf, $nrseqcontainer);
    }
    
    public function getSeparacao($params){
        return $this->lancamentoExpedicaoPedidoFactory->getSeparacao($params);
    }
    
    public function updateNrExpedicao($cdfilial, $nrexpedicao, $cdrotatrans, $dsqtdevolped, $nrlanctonf, $cdopergera){
        return $this->lancamentoExpedicaoPedidoFactory ->updateNrExpedicao($cdfilial, $nrexpedicao, $cdrotatrans, $dsqtdevolped, $nrlanctonf, $cdopergera);
    }
    
    public function insereNrExpedicao($cdfilial, $nrexpedicao, $cdfilialped, $cdviatura, $cdopersep, $cdoperconf){
        return $this->lancamentoExpedicaoPedidoFactory->insereNrExpedicao($cdfilial, $nrexpedicao, $cdfilialped, $cdviatura, $cdopersep, $cdoperconf);
    }


    /* FIM METODOS APP CONFERENCIA DE SEPARACAÇÃO */
}