<?php
namespace Teknisa\PED\Modules\Pedidos\Services;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\GER\Utilities\Environment;
use Teknisa\PED\Modules\Pedidos\Factories\Ped05001EquipeVendedorMetaFactory;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\GER\Services\NewCode;

class Ped05001EquipeVendedorMetaService{

	protected $environment;
	protected $dataSourceManager;
	protected $newCode;
	protected $equipeFactory;

    public function __construct(Environment $environment, NewCode $newCode, $dataSourceManager, Ped05001EquipeVendedorMetaFactory $equipeFactory){
        $this->environment = $environment;
        $this->dataSourceManager = $dataSourceManager;
        $this->newCode = $newCode;
        $this->Ped05001EquipeVendedorMetaFactory = $equipeFactory;  
    }
    
    public function geraNrSeq($__new_code_pk) {
        $nrseq = $this->newCode->getCodeByTableName($__new_code_pk, $this->environment->getNrOrgTrab(), 1, 4);
        return array($nrseq, $this->environment->getNrOrgTrab());
    }
    
    public function searchMembrosEquipe($cdequipe) {
        $nrorg = $this->environment->getNrOrgTrab();
        $result = $this->Ped05001EquipeVendedorMetaFactory->searchMembrosEquipe($cdequipe, $nrorg);
        return $result;
    }
    
    public function geraMembrosSub($rows) {
        $membros = array();
        for ($i = 0; $i < count($rows[1]); $i++) {
            for ($e = 0; $e < count($rows[2]); $e++) {
                $currentEquipe = $rows[1][$i];
                $currentMembro = $rows[2][$e];
                
                $newMembro = array();
                $newMembro['NRORG'] = $currentEquipe['NRORG'];
                $newMembro['CDEQUIPE'] = $currentEquipe['CDEQUIPE'];
                $newMembro['CDVENDEDOR'] = $currentMembro['CDVENDEDOR'];
                $nrseq = $this->geraNrSeq('EQUIPEVENDEDOR');
                $newMembro['NRSEQEQUIPEVEND'] = $nrseq[0];
                array_push($membros, $newMembro);
            }
        }
        return $membros;
    }
    
    public function geraMembrosAdd($rows) {
        $membros = array();
        for ($i = 0; $i < count($rows[1]); $i++) {
            $newMembros = $rows[2];
            $existing = $this->searchMembrosEquipe($rows[1][$i]["CDEQUIPE"]);
            for ($j = 0; $j < count($existing); $j++) {
                for ($e = 0; $e < count($newMembros); $e++) {
                    if ($existing[$j]['CDVENDEDOR'] == $newMembros[$e]['CDVENDEDOR']) {
                        array_splice($newMembros, $e, 1);
                    }
                }
            }
            for ($e = 0; $e < count($newMembros); $e++) {
                $currentEquipe = $rows[1][$i];
                $currentMembro = $rows[2][$e];
                
                $newMembro = array();
                $newMembro['NRORG'] = $currentEquipe['NRORG'];
                $newMembro['CDEQUIPE'] = $currentEquipe['CDEQUIPE'];
                $newMembro['CDVENDEDOR'] = $currentMembro['CDVENDEDOR'];
                $nrseq = $this->geraNrSeq('EQUIPEVENDEDOR');
                $newMembro['NRSEQEQUIPEVEND'] = $nrseq[0];
                array_push($membros, $newMembro);
            }
        }
        return $membros;
    }
    
    public function geraImportMembrosSub($rows) {
        $membros = array();
        $membrosToSave = array();
        for ($i = 0; $i < count($rows[1]); $i++) {
            $existing = $this->searchMembrosEquipe($rows[1][$i]["CDEQUIPE"]);
            for ($j = 0; $j < count($existing); $j++) {
                array_push($membros, $existing[$j]);
            }
        }
    
        for ($i = 0; $i < count($membros); $i++) {
            $vendedor = $membros[$i]['CDVENDEDOR'];
            if($i<count($membros)+1) {
                for ($e = $i+1; $e < count($membros); $e++) {
                    if ($membros[$e]['CDVENDEDOR'] == $vendedor) {
                        array_splice($membros, $e, 1);
                    }
                }   
            }
        }
        
        for ($e = 0; $e < count($membros); $e++) {
            $currentEquipe = $rows[3];
            $currentMembro = $membros[$e];
            
            $newMembro = array();
            $newMembro['NRORG'] = $currentEquipe['NRORG'];
            $newMembro['CDEQUIPE'] = $currentEquipe['CDEQUIPE'];
            $newMembro['CDVENDEDOR'] = $currentMembro['CDVENDEDOR'];
            $nrseq = $this->geraNrSeq('EQUIPEVENDEDOR');
            $newMembro['NRSEQEQUIPEVEND'] = $nrseq[0];
            array_push($membrosToSave, $newMembro);
        }
        return $membrosToSave;
    }
    
     public function geraImportMembrosAdd($rows) {
        $membros = array();
        $membrosToSave = array();
        
        for ($i = 0; $i < count($rows[1]); $i++) {
            $existing = $this->searchMembrosEquipe($rows[1][$i]["CDEQUIPE"]);
            for ($j = 0; $j < count($existing); $j++) {
                array_push($membros, $existing[$j]);
            }
        }
        
        $existing = $this->searchMembrosEquipe($rows[3]["CDEQUIPE"]);
        for ($j = 0; $j < count($existing); $j++) {
            array_push($membros, $existing[$j]);
        }
    
        for ($i = 0; $i < count($membros); $i++) {
            $vendedor = $membros[$i]['CDVENDEDOR'];
            if($i<count($membros)+1) {
                for ($e = $i+1; $e < count($membros); $e++) {
                    if ($membros[$e]['CDVENDEDOR'] == $vendedor) {
                        array_splice($membros, $e, 1);
                    }
                }   
            }
        }
        
        for ($e = 0; $e < count($membros); $e++) {
            $currentEquipe = $rows[3];
            $currentMembro = $membros[$e];
            
            $newMembro = array();
            $newMembro['NRORG'] = $currentEquipe['NRORG'];
            $newMembro['CDEQUIPE'] = $currentEquipe['CDEQUIPE'];
            $newMembro['CDVENDEDOR'] = $currentMembro['CDVENDEDOR'];
            $nrseq = $this->geraNrSeq('EQUIPEVENDEDOR');
            $newMembro['NRSEQEQUIPEVEND'] = $nrseq[0];
            array_push($membrosToSave, $newMembro);
        }
        return $membrosToSave;
    }
}
