<?php
namespace Teknisa\PED\Modules\Pedidos\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\PED\Modules\Pedidos\Factories\Ped05700importacaoSolicitacaoComprasFactory;
use Teknisa\Libs\Util\DateUtil;
use Teknisa\Libs\Util\NewCode;
use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DataSource\Manager\SQL\ManagerImpl;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;

class Ped05700importacaoSolicitacaoComprasService{
    protected $entityManager;
	protected $environment;
    protected $dataSourceManager;
	protected $Ped05700importacaoSolicitacaoComprasFactory;

	public function __construct(EntityManager $entityManager, Environment $environment, ManagerImpl $dataSourceManager, $Ped05700importacaoSolicitacaoComprasFactory){
		$this->entityManager        	= $entityManager;
		$this->environment				= $environment;
        $this->dataSourceManager		= $dataSourceManager;
		$this->Ped05700importacaoSolicitacaoComprasFactory = $Ped05700importacaoSolicitacaoComprasFactory;
        
	}
    
    
    public function buscaPrecoBase ($cdfilial, $cdcliente, $cdvendedor, $cdmodpgto){
        $precoBase = $this->Ped05700importacaoSolicitacaoComprasFactory->buscaPrecoBase($cdfilial, $cdcliente, $cdvendedor, $cdmodpgto);
        
        return $precoBase;
    }
    
    public function buscaitemSoliRelacProdSC($cdfilsoli, $cdfillan, $nrsolicmp, $dtprogentr, $tdtprogentr, $cdfilial){
        $itemSoliRelacProdSC = $this->Ped05700importacaoSolicitacaoComprasFactory->buscaitemSoliRelacProdSC($cdfilsoli, $cdfillan, $nrsolicmp, $dtprogentr, $tdtprogentr, $cdfilial);
    
        return $itemSoliRelacProdSC;
    }

    public function buscaProdFatorDtEnt($cdfilial,$nrsolicmp,$tdtprogentr,$cdfillan,$dtprogentr,$cdfilsoli){
        $prodFatorDtEnt = $this->Ped05700importacaoSolicitacaoComprasFactory->buscaProdFatorDtEnt($cdfilial,$nrsolicmp,$tdtprogentr,$cdfillan,$dtprogentr,$cdfilsoli);
        
        return $prodFatorDtEnt;
    }
    
    public function buscaPrecoBaseDtEnt($cdfilial, $nrsolicmp, $tdtprogentr, $cdfillan, $dtprogentr, $cdfilsoli, $precoBase, $cdcliente, $cdmodpgto, $cdfatpreco){
        $precoBaseDtEnt = $this->Ped05700importacaoSolicitacaoComprasFactory->buscaPrecoBaseDtEnt($cdfilial, $nrsolicmp, $tdtprogentr, $cdfillan, $dtprogentr, $cdfilsoli, $precoBase, $cdcliente, $cdmodpgto, $cdfatpreco);
        
        return $precoBaseDtEnt;
    }
    
    public function buscaItemSoli(){
        $itemSoli = $this->Ped05700importacaoSolicitacaoComprasFactory->buscaItemSoli($cdfilsoli, $cdfillan, $nrsolicmp, $dtprogentr, $tdtprogentr);
        
        return $itemSoli;
    }
    
    public function buscaProdFator($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $fator){
        $itemSoli = $this->Ped05700importacaoSolicitacaoComprasFactory->buscaProdFator($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $fator);
        
        return $prodFator;
    }
    
    public function buscaFator($sgfatpreco, $tsgfatpreco){
        $fator = $this->Ped05700importacaoSolicitacaoComprasFactory->buscaFator($sgfatpreco, $tsgfatpreco);
        
        return $fator;
    }
    
    public function selectPrecoBase($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult){
        $selectPrecoBase = $this->Ped05700importacaoSolicitacaoComprasFactory->selectPrecoBase($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult);
        
        return $selectPrecoBase;
    }
    
    public function selectDataEndPed($cdfilsoli, $cdfillan, $nrsolicmp){
        $selectDataEndPed = $this->Ped05700importacaoSolicitacaoComprasFactory->selectDataEndPed($cdfilsoli, $cdfillan, $nrsolicmp);
        
        return $selectDataEndPed;
    }
    
    public function selectValidaPreco($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult, $dtentrega){
        $selectValidaPreco = $this->Ped05700importacaoSolicitacaoComprasFactory->selectValidaPreco($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult, $dtentrega);
        
        return $selectValidaPreco;
    }
    
    public function selectVerificaPrecoZerado($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult, $dtentrega){
        $selectVerificaPrecoZerado = $this->Ped05700importacaoSolicitacaoComprasFactory->selectVerificaPrecoZerado($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult, $dtentrega);
        
        return $selectVerificaPrecoZerado;
    }
    
    public function selectFilial($cdfilial){
        $selectFilial = $this->Ped05700importacaoSolicitacaoComprasFactory->selectFilial($cdfilial);
        
        return $selectFilial;
    }
    
    public function selectExisteSoliCmpDtPed($cdfillanca, $cdfilisoli, $nrsolicmp, $dtprogentr){
        $selectExisteSoliCmpDtPed = $this->Ped05700importacaoSolicitacaoComprasFactory->selectExisteSoliCmpDtPed($cdfillanca, $cdfilisoli, $nrsolicmp, $dtprogentr);
        
        $retorno = ($selectExisteSoliCmpDtPed > 0.0) ? true : false;
        return $retorno;
    }
    
    public function gravaPedido($cdfilial, $prxPedido, $operador, $dtprogentr, $cdfillanca, $cdfilisoli, $nrsolicmp){
        $selectExisteSoliCmpDtPed = $this->Ped05700importacaoSolicitacaoComprasFactory->gravaPedido($cdfilial, $prxPedido, $operador, $dtprogentr, $cdfillanca, $cdfilisoli,$nrsolicmp);
        
        return $selectExisteSoliCmpDtPed;
    }
    
    public function gravaItempedido($cdfilial, $nrpedido, $cdfatpreco, $cdproduto, $qtitemped, $dtentitped, $dtentped){
        $selectExisteSoliCmpDtPed = $this->Ped05700importacaoSolicitacaoComprasFactory->gravaItempedido($cdfilial, $nrpedido, $cdfatpreco, $cdproduto, $qtitemped, $dtentitped, $dtentped);
        
        return $selectExisteSoliCmpDtPed;
    }
    
    public function geraReserva($cdfilial, $nrpedido){
        $geraReserva = $this->Ped05700importacaoSolicitacaoComprasFactory->geraReserva($cdfilial, $nrpedido);
    }
    
    public function selectCalcTotImpos($cdfilial, $nrpedido){
        $selectCalcTotImpos = $this->Ped05700importacaoSolicitacaoComprasFactory->selectCalcTotImpos($cdfilial, $nrpedido);
        
        return $selectCalcTotImpos;
    }
    
    public function selectConsImposPedTot($cdfilial, $nrpedido, $cdimposto){
        $selectCalcTotImposPedTot = $this->Ped05700importacaoSolicitacaoComprasFactory->selectConsImposPedTot($cdfilial, $nrpedido, $cdimposto);
        
        return $selectCalcTotImposPedTot;
    }
    
    public function insertItemPedTot($cdfilial, $nrpedido, $cdimposto, $vrtotimpped, $vrtotbcalcped){
        $InsItemPedTot = $this->Ped05700importacaoSolicitacaoComprasFactory->selectInsItemPedTot($cdfilial, $nrpedido, $cdimposto, $vrtotimpped, $vrtotbcalcped);
    }
    
    public function updateItemPedTot($cdfilial, $nrpedido, $cdimposto, $vrtotimpped, $vrtotbcalcped){
        $updateItemPedTot = $this->Ped05700importacaoSolicitacaoComprasFactory->updateItemPedTot($cdfilial, $nrpedido, $cdimposto, $vrtotimpped, $vrtotbcalcped);
    }
};